(*******************************************************************************
DELPHI HIKVISION SDK v.1.1
Max Gomonov
07.03.2013
*******************************************************************************)

unit HikVisionSDK;


interface

uses
ShellAPI,Windows;
const

SERIALNO_LEN =48; 

SET_PRESET	 =8 ;	// EeOAOOAa 
CLE_PRESET	 =9 ;	// Ca?yOOAa 
GOTO_PRESET	 =39 ;	// ???OOAa 

LIGHT_PWRON	 =2 ;	// ?OI???acO? */ 
WIPER_PWRON	 =3 ;	// ?OI?OeE????O */ 
FAN_PWRON	 =4 ;	// ?OI?cEE???O */ 
HEATER_PWRON	 =5 ;	// ?OI??OEE?????O */ 
AUX_PWRON	 =6 ;	// ?OI???OuEe????O */ 

ZOOM_IN	 =11 ;	// ???aOOEUESSa?o(AEa?o) */ 
ZOOM_OUT	 =12 ;	// ???aOOEUESSa??(AEa??) */
FOCUS_NEAR	 =13 ;	// ??aOOEUESSC? */ 
FOCUS_FAR	 =14 ;	// ??aOOEUESS?o? */ 
IRIS_OPEN	 =15 ;	// ?aEOOEUESSA?o */ 
IRIS_CLOSE	 =16 ;	// ?aEOOEUESSEo?? */ 
TILT_UP	 =21 ;	// O?I?OOSSAEUEEINo */ 
TILT_DOWN	 =22 ;	// O?I?OOSSAEUEIA? */ 
PAN_LEFT	 =23 ;	// O?I?OOSSAEUE?o?? */ 
PAN_RIGHT	 =24 ;	// O?I?OOSSAEUEOO?? */ 
PAN_AUTO	 =29 ;	// O?I?OOSSAEUE?oOO?O?E?Ae */ 

//?eOOIA???IEOO???EyOO 
NET_DVR_FILE_SUCCESS	 =1000;	 //nAIA???AI? 
NET_DVR_FILE_NOFIND	 =1001;	 //AO?IA?? 
NET_DVR_ISFINDING	 =1002;	 //OyOU?eOOIA?? 
NET_DVR_NOMOREFILE	 =1003;	 //?eOOIA??EAO??uaAIA?? 
NET_DVR_FILE_EXCEPTION =1004;	 //?eOOIA??EOi?? 

NET_DVR_PLAYSTART	 =1;//??E???A 
NET_DVR_PLAYSTOP	 =2;//I?O???A 
NET_DVR_PLAYPAUSE	 =3;//OYI???A 
NET_DVR_PLAYRESTART	 =4;//O????A 
NET_DVR_PLAYFAST	 =5;//?iA 
NET_DVR_PLAYSLOW	 =6;//AyA 
NET_DVR_PLAYNORMAL	 =7;//Oy??EUE 
NET_DVR_PLAYFRAME	 =8;//?O?A 
NET_DVR_PLAYSTARTAUDIO =9;//?o??EuOo 
NET_DVR_PLAYSTOPAUDIO	 =10;//?OOEuOo 
NET_DVR_PLAYAUDIOVOLUME=11;//??UOoA? 
NET_DVR_PLAYSETPOS	 =12;//?AaIA??OAA?oE 
NET_DVR_PLAYGETPOS	 =13;//nE?IA??OAA?oE 
NET_DVR_PLAYGETTIME	 =14;//nE?CON???AAE?a 
NET_DVR_PLAYGETFRAME	 =15;//nE?CON???AAO?Ey 
NET_DVR_GETTOTALFRAMES =16;//nE?C??AIA???UAO?Ey 
NET_DVR_GETTOTALTIME =17;//nE?C??AIA???UAE?a 
NET_DVR_THROWBFRAME	 =20;//?BO?

//  
COMM_ALARM = $1100;
COMM_ALARM_RULE = $1102;
COMM_ALARM_PDC = $1103;
COMM_TRADEINFO = $1500;
COMM_UPLOAD_PLATE_RESULT = $2800;
COMM_ALARM_V30 = $4000;
COMM_IPCCFG = $4001;
COMM_IPCCFG_V31 = $4002;
COM_PUSHALARM = $1200;
COM_PUSHALARM_V30 = $1201;



type 

LPNET_DVR_DEVICEINFO = ^NET_DVR_DEVICEINFO; 
NET_DVR_DEVICEINFO = packed record 
sSerialNumber: array [0..SERIALNO_LEN] of BYTE; //?oA??A 
byAlarmInPortNum :BYTE;	 //DVR???EaEe?oEy
byAlarmOutPortNum:BYTE;	 //DVR???Ea?o?oEy 
byDiskNum :BYTE; //DVR O?AI?oEy 
byDVRType :BYTE; //DVRAa?I, 
byChanNum :BYTE; //DVR I?A?oEy 
byStartChan :BYTE;	 //??E?I?A?A,AyEcDVS-1,DVR - 1 
end; 

LPNET_DVR_CLIENTINFO = ^NET_DVR_CLIENTINFO;
NET_DVR_CLIENTINFO = packed record
lChannel :LongInt;//I?A?A
lLinkMode:LongInt;//A?O?E?: 0??TCP?E?,1??UDP?E?,2??a???E?,3 - RTP?E??4-OoEO?O??(TCP)
hPlayWnd :HWND;//??A??UA?au,I?NULLiE????AI?Io
sMultiCastIP:PChar;//a???eOO
end; 

LPNET_DVR_TIME = ^NET_DVR_TIME; 
NET_DVR_TIME = packed record 
dwYear :DWORD;	 //Ae 
dwMonth :DWORD;	 //OA 
dwDay :DWORD;	 //EO 
dwHour :DWORD;	 //E 
dwMinute:DWORD;	 //O 
dwSecond:DWORD;	 //Ae 
end; 

LPNET_DVR_FIND_DATA =^NET_DVR_FIND_DATA;
NET_DVR_FIND_DATA = packed record 
sFileName: array [0..99] of char;//IA??Au 
struStartTime : NET_DVR_TIME;//IA??A??E?E?a 
struStopTime : NET_DVR_TIME;//IA??A?aEoE?a 
dwFileSize : DWORD;//IA??A?o??
end;
// jpeg
LPNET_DVR_JPEGPARA =^NET_DVR_JPEGPARA;
NET_DVR_JPEGPARA = packed record
  wPicSize: Word;
  wPicQuality: Word;
end;

//alarm info
LPNET_DVR_ALARMINFO = ^NET_DVR_ALARMINFO;
NET_DVR_ALARMINFO = packed record
  dwAlarmType: DWORD;
  dwAlarmInputNumber: DWORD;
  dwAlarmOutputNumber: DWORD;
  dwAlarmRelateChannel: DWORD;
  dwChannel: DWORD;
  dwDiskNumber: DWORD;
end;

LPNET_DVR_ALARMER = ^NET_DVR_ALARMER;
NET_DVR_ALARMER = packed record
  byUserIDValid: BYTE;
  bySerialValid: BYTE;
  byVersionValid: BYTE;
  byDeviceNameValid: BYTE;
  byMacAddrValid: BYTE;
  byLinkPortValid: BYTE;
  byDeviceIPValid: BYTE;
  bySocketIPValid: BYTE;
  lUserID: Longint;
  sSerialNumber: BYTE;
  dwDeviceVersion: DWORD;
  sDeviceName: CHAR;
  byMacAddr: BYTE;
  wLinkPort: Word;
  sDeviceIP: CHAR;
  sSocketIP: CHAR;
  byIpProtocol: BYTE;
  byRes2: BYTE;
end;

LPNET_DVR_START_PIC_VIEW_INFO = ^NET_DVR_START_PIC_VIEW_INFO;
NET_DVR_START_PIC_VIEW_INFO = packed record
  dwSize: DWORD;
  dwSignalIndex: DWORD;
  sDeviceID: Byte;
  byChanIndex: Byte;
  byRes: byte;
end;

PIC_PREVIEW_DATATYPE = (NET_DVR_DATA_BMP  = 0,
  NET_DVR_START_CALLBACK,
  NET_DVR_STREAM_SYSHEAD,
  NET_DVR_STREAM_DATA 
);


// 
fRealDataCallBack = procedure (lRealHandle: LongInt; dwDataType:LongWord;pBuffer:PByte;dwBufSize:LongWord;dwUser: LongWord); stdcall;
fSetStandardDataCallBack = procedure(lRealHandle: LongInt; dwDataType:LongWord;pBuffer:BYTE;dwBufSize:LongWord;dwUser: LongWord); stdcall;
fDrawFunCallBack = procedure(lRealHandle: LongInt; DCHandle: HDC; dwUser: Word); stdcall;
fMessageCallBack = procedure(lCommand: LongInt; pAlarmer: LPNET_DVR_ALARMER; pAlarmInfo: PChar; dwBufLen: DWORD; dwUser: DWORD); stdcall;
fStartPicPreviewCB = procedure(nScreenPicHandle: Longint; dwDataType: DWORD; pBuffer: PBYTE; dwBufSize: DWORD; pUser: PDWORD); stdcall;

// , ....
function NET_DVR_Init:Boolean;stdcall; external 'HCNetSDK.dll' name 'NET_DVR_Init';
function NET_DVR_Cleanup:Boolean;stdcall; external 'HCNetSDK.dll' name 'NET_DVR_Cleanup'; 
function NET_DVR_Login(sDVRIP :pchar;wDVRPort :WORD;sUserName :pchar;sPassword :pchar;lpDeviceInfo :LPNET_DVR_DEVICEINFO):longint;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_Login';
function NET_DVR_Login_V30(sDVRIP :pchar;wDVRPort :WORD;sUserName :pchar;sPassword :pchar;lpDeviceInfo :LPNET_DVR_DEVICEINFO):longint;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_Login_V30'; 
function NET_DVR_Logout(lUserID :longint):boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_Logout'; 
function NET_DVR_RealPlay(lUserID :longint;lpClientInfo :LPNET_DVR_CLIENTINFO):longint;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_RealPlay';
function NET_DVR_RealPlay_V30(lUserID:LongInt;lpClientInfo:NET_DVR_CLIENTINFO;FrealDataCallBack:fRealDataCallBack;dwUser:LongWord;bBlocked:Bool):LongInt;stdcall; External 'HCNetSDK.dll' name 'NET_DVR_RealPlay_V30';
function NET_DVR_StopRealPlay(lRealHandle :longint):boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_StopRealPlay';

//PTZ
function NET_DVR_PTZControl(lRealHandle: Longint; dwPTZCommand: LongWord; dwStop: LongWord):boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_PTZControl';
function NET_DVR_PTZControl_Other(lUserID: LongInt; lChannel: LongInt; dwPTZCommand: LongWord; dwStop: LongWord):boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_PTZControl_Other'; 
function NET_DVR_TransPTZ(lRealHandle: LongInt; pPTZCodeBuf: PChar; dwBufSize: LongWord):boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_TransPTZ'; 
function NET_DVR_TransPTZ_Other(lUserID: LongInt; lChannel: LongInt; pPTZCodeBuf: PChar; dwBufSize: LongWord):boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_TransPTZ_Other'; 
function NET_DVR_PTZPreset(lRealHandle: LongInt; dwPTZPresetCmd: LongWord; dwPresetIndex: LongWord): boolean;stdcall; external 'HCNetSDK.dll' name 'NET_DVR_PTZPreset'; 
function NET_DVR_PTZPreset_Other(lUserID: LongInt; lChannel: LongInt; dwPTZPresetCmd: LongWord; dwPresetIndex: LongWord):boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_PTZPreset_Other'; 

//
function NET_DVR_FindFile(lUserID:LongInt;lChannel:LongInt;dwFileType:DWORD;lpStartTime:LPNET_DVR_TIME;lpStopTime:LPNET_DVR_TIME ):longint;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_FindFile'; 
function NET_DVR_FindNextFile(lFindHandle:LongInt ;lpFindData:LPNET_DVR_FIND_DATA ):longint;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_FindNextFile'; 
function NET_DVR_FindClose(lFindHandle:LongInt ):Boolean ;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_FindClose'; 

//
function NET_DVR_PlayBackByName(lUserID :longint;sPlayBackFileName :pchar;hWnd :HWND):longint;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_PlayBackByName'; 
function NET_DVR_PlayBackByTime(lUserID :longint;lChannel :longint;lpStartTime :LPNET_DVR_TIME;lpStopTime :LPNET_DVR_TIME;hWnd :HWND):longint;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_PlayBackByTime'; 
function NET_DVR_StopPlayBack(lPlayHandle :longint):boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_StopPlayBack'; 
function NET_DVR_PlayBackControl(lPlayHandle :longint;dwControlCode :DWORD;dwInValue :DWORD;lpOutValue :PDWORD):boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_PlayBackControl'; 
function NET_DVR_PlayBackSaveData(lPlayHandle :longint;sFileName :pchar):boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_PlayBackSaveData';
function NET_DVR_StopPlayBackSave(lPlayHandle :longint):boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_StopPlayBackSave';


//   callback 
function NET_DVR_SetRealDataCallBack(lRealHandle: LongInt;FrealDataCallBack:fRealDataCallBack;dwUser: Word):Boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_SetRealDataCallBack';
function NET_DVR_SetStandardDataCallBack(lRealHandle: LongInt;FSetStandardDataCallBack:fSetStandardDataCallBack;dwUser: Word):Boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_SetStandardDataCallBack';
function NET_DVR_RigisterDrawFun(lRealHandle: LongInt;cbDrawFun:fDrawFunCallBack;dwUser: Word):Boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_RigisterDrawFun';
function NET_DVR_SetDVRMessageCallBack_V30(cbMessageCalBack: fMessageCallBack; dwUser: DWORD): boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_SetDVRMessageCallBack_V30';
function NET_DVR_StartPicPreview(lUserID: Longint; lpStruStartPicView: LPNET_DVR_START_PIC_VIEW_INFO;StartPicViewCB:fStartPicPreviewCB;pUserData: PDWORD):Longint;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_StartPicPreview';

// 
function NET_DVR_CaptureJPEGPicture_NEW(lUserID: Longint; lChannel: LongInt; lpJpegPara: LPNET_DVR_JPEGPARA; sJpegPicBuffer: PChar; dwPicSize: DWORD; lpSizeReturned: PDWORD): Boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_CaptureJPEGPicture_NEW';
function NET_DVR_CaptureBMPPicture_NEW(lUserID: Longint; lChannel: LongInt; lpJpegPara: LPNET_DVR_JPEGPARA; sJpegPicBuffer: PChar; dwPicSize: DWORD; lpSizeReturned: PDWORD): Boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_CaptureBMPPicture_NEW';
function NET_DVR_CaptureJPEGPicture(lUserID: LongInt; lChannel: LongInt; lpJpegPara: LPNET_DVR_JPEGPARA; dest:PChar): Boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_CaptureJPEGPicture';
function NET_DVR_SetCapturePictureMode(dwCaptureMode: DWORD): Boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_SetCapturePictureMode';

//  
function NET_DVR_SaveRealData(lRealHandle: Longint; sFileName: PChar):boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_SaveRealData';
function NET_DVR_StopSaveRealData(lRealHandle: Longint):boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_StopSaveRealData';


//player
function NET_DVR_GetRealPlayerIndex(lRealHandle: LongInt):Boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_GetRealPlayerIndex';


 //
function NET_DVR_PlayBackCaptureFile(lPlayHandle :longint;sFileName :pchar):boolean;stdcall; external 'HCNetSDK.dll' name 'NET_DVR_PlayBackCaptureFile'; 
function NET_DVR_GetFileByName(lUserID :longint ;sDVRFileName : pchar;sSavedFileName : pchar):longint;stdcall; external 'HCNetSDK.dll' name 'NET_DVR_GetFileByName';
function NET_DVR_GetFileByTime(lUserID :longint ;lChannel :longint; lpStartTime :LPNET_DVR_TIME;lpStopTime : LPNET_DVR_TIME ; sSavedFileName :pchar):longint;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_GetFileByTime'; 
function NET_DVR_StopGetFile(lFileHandle :longint):boolean;stdcall;external 'HCNetSDK.dll' name 'NET_DVR_StopGetFile';
function NET_DVR_GetDownloadPos(lFileHandle :longint):integer;stdcall; external 'HCNetSDK.dll' name 'NET_DVR_GetDownloadPos';


function NET_DVR_SetupAlarmChan_V30(lUserID :longint):longint;stdcall; external 'HCNetSDK.dll' name 'NET_DVR_SetupAlarmChan';
var
m_port:Integer; 
implementation

end.
